﻿	function Errorhandling(error, file, row)
    {
      alert("Error: " + error + "\nFile: " + file + "\nRow: " + row);
    }
	
    var maxOrder = 4;
    var a = new Array(8);
	var al = new Array(8);
	var r = new Array(8);
    var x = new Array(8);
    var y = new Array(8);
	var actKnot;
	var knotName;

    function calculate()
    {
		for(var i=0; i < maxOrder; i++)
		{
			a[i] = new Array(maxOrder);
			al[i] = new Array(maxOrder);
			r[i] = new Array(maxOrder);
			for(var j=0; j < maxOrder; j++)
			{
				a[i][j] = document.getElementById("A" + (i+1) + (j+1)).value; 
			}
			y[i] = 1.0 * document.getElementById("Y" + (i+1)).value;
			x[i] = 0; 
		}
		try
		{
			RunGivens(maxOrder);
			
			for(var i=0; i < maxOrder; i++)
			{
				for(var j=0; j < maxOrder; j++)
				{
					document.getElementById("A" + (i+1) + (j+1)).value = a[i][j]; 
				}
				document.getElementById("Y" + (i+1)).value = y[i].toFixed(3);
			}
			
			solve()
      
			for(var i=0; i < maxOrder; i++)
			{
				document.getElementById("X" + (i+1)).value = x[i].toFixed(3);  
			}
		}
		catch(er)
		{
			alert(er);
		}
   }


   function MultMatrix(p, q)
   {
        var i, j, k;
        var al = new Array(maxOrder);
        var yl = new Array(maxOrder);
		for(var i=0; i < maxOrder; i++)
		{
			al[i] = new Array(maxOrder);
        }
        
        for (i = 0; i < maxOrder; i++)
		{
            if ((i == p) || (i == q)) // only calculate row p and q
            {
                yl[i] = 0.0;
                for (j = 0; j < maxOrder; j++)
                {
                    yl[i] = yl[i] + (y[j] * r[i][j]);
                    al[i][j] = 0.0;
                    for (k = 0; k < maxOrder; k++)
                    {
                        al[i][j] = al[i][j] + (r[i][k] * a[k][j]);
                    }
                }
            }
            else
            {
                yl[i] = y[i];
                for (j = 0; j < maxOrder; j++)
                {
                    al[i][j] = a[i][j];
                }
            }
        }
		
        for (i = 0; i < maxOrder; i++)
        {
            y[i] = yl[i];
            for (j = 0; j < maxOrder; j++)
            {
                a[i][j] = al[i][j];
            }
        }
    }
    

    function CalcRMatrix(p, q)
    {
        var i, j;
        var radius;
        radius = Math.sqrt(a[p][p] * a[p][p] + a[q][p] * a[q][p]);
        for (i = 0; i < maxOrder; i++)
        {
            for (j = 0; j < maxOrder; j++)
            {
               r[i][j] = 0.0;
            }
            r[i][i] = 1.0;
        }
        if (radius != 0.0)
        {
            if (a[p][p] == 0.0)
            {
                r[p][p] = 0.0;
                r[p][q] = 1.0;
            }
            else
            {
                r[p][p] = a[p][p] / radius;
                r[p][q] = a[q][p] / radius;
            }
            r[q][q] = r[p][p];
            r[q][p] = -r[p][q];
        }
    }
	
	function RunGivens(maxOrder)
    {
        var i, k;
        for (i = 0; i < maxOrder; i++)
        {
            for (k = i + 1; k < maxOrder; k++)
            {
                if (a[k][i] != 0.0)
                {
                    CalcRMatrix(i, k);
                    MultMatrix(i, k);
                }
            }
        }
    }


    function solve()
    {
      var k, l;
      for (k = maxOrder - 1; k >= 0; k--)
      {
        for (l = maxOrder - 1; l >= k; l--)
        {
           y[k] = y[k] - x[l] * a[k][l];
        }
        if(Math.abs(a[k][k]) > 1e-20)
          x[k] = y[k] / a[k][k];
        else
          throw "Calculation eror: Division by cero";
      }
    }

    function createMatrix(order, knot)
    {
	  knotName = knot;
	  actKnot = document.getElementById(knot);
      for (var i = 1; i <= order; i++)
      {
        var  tableRow = document.createElement("p");
		actKnot.appendChild(tableRow);
        for (var j = 1; j <= order; j++)
        {
          var field = document.createElement("input");
          field.setAttribute("id","A" + i + j);
		  field.setAttribute("style","width:60px");
          tableRow.appendChild(field);
        }
		var text = document.createTextNode(" = ");
	    tableRow.appendChild(text);
        var res = document.createElement("input");
        res.setAttribute("id","Y" + i);
		res.setAttribute("style","width:60px");
        tableRow.appendChild(res);
     }
     var  tableRow = document.createElement("p");
	 actKnot.appendChild(tableRow);
     for (var i = 1; i <= order; i++)
     {
       var res = document.createElement("input");
       res.setAttribute("id","X" + i);
	   res.setAttribute("style","width:60px");
       tableRow.appendChild(res);
     }
	}
 
	function selectOrder()
	{
		const input = document.getElementById('idOrder');
		maxOrder = input.value;
		a = new Array(maxOrder);
		ai = new Array(maxOrder);
		r = new Array(maxOrder);
        x = new Array(maxOrder);
        y = new Array(maxOrder);
		for(var i = actKnot.childNodes.length - 1; i >= 0; i--)
		{
		   var el = actKnot.childNodes[i];
		   actKnot.removeChild(el);
		}
		createMatrix(maxOrder, knotName);
	}